printHelp()
{
    echo "Spusteni skriptu"
    echo "./prepare.sh -h"
    echo "./prepare.sh -v TMR+DuplexVoter|TMR|CheckerDuplex|Duplex entity [-p paths_to_packages]"
    echo "-h                                            zobrazeni napovedy"
    echo "-v TMR+DuplexVoter|TMR|CheckerDuplex|Duplex   FT varianta "  
    echo "-p paths_to_packages                          cesty k balickum s definicemi typu"
    echo "entity                                        cesta k VHD souboru zabezpecovane entity"
}

genericDevice="xc5vsx50t"
genericDeviceFamily="virtex5"
genericPackage="ff1136"

if [ $# -eq 1 ] && [ $@ == "-h" ]; then
    printHelp
    exit 1
fi 

echo ""
echo "FT zabezpeceni komponenty "
echo "=========================="
echo ""

if [ $# -eq 1 ] && [ $@ == "-h" ]; then
    printHelp
    exit 1
fi 


variant=""
paths=()
while getopts ":v:p:" parameter
do
    case "$parameter" in
        v) variant=$OPTARG;;
        p) paths=(${OPTARG// / });;
        \?) echo "Zadan chybny parametr!"; echo ""; printHelp; exit 1;;
    esac 
    
done

shift $(($OPTIND - 1))


case $variant in
    "TMR+DuplexVoter") variantName="TMR a duplexni voter (celkem 4PRM)";;
    "TMR") variantName="TMR a nechraneny voter (celkem 3PRM)";;
    "CheckerDuplex") variantName="Duplexni provedeni s jednim checkerem (celkem 3PRM)";;
    "") echo "Je treba zadat FT variantu!";printHelp; exit 1;;
    *) echo "Chybne zadana FT varianta!";printHelp; exit 1;;
esac 


if [ "$#" -ne 1 ]; then
    echo "Nebyl zadan VHD soubor s komponentou!"
    printHelp
    exit 1
else
    filename=$@
fi

if ! [ -f $filename ]; then
    echo "Soubor s komponentou neexistuje!"
    printHelp
    exit 1
fi

for i in "${paths[@]}"; do
    echo "$i"
done


echo "Nastavene hodnoty"
echo "FT varianta:          $variantName"
echo "Soubor s komponentou: $filename"

SCRIPT_DIR=$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )
ACT_DIR=$( pwd )

echo "Adresar skriptu:  "$SCRIPT_DIR
echo "Pracovni adresar: "$ACT_DIR

if [ -d "$ACT_DIR/FT" ]; then
    echo "Adresar FT jiz existuje! Bude smazan a znovu vytvoren."
    rm -r $ACT_DIR/FT
    mkdir $ACT_DIR/FT
else
    mkdir $ACT_DIR/FT
fi

python $SCRIPT_DIR/entity_wrapper.py -f $filename -o $ACT_DIR/FT/fuPRM.vhd -n FU

cp $filename $ACT_DIR/FT

case $variant in
    "TMR+DuplexVoter") cp $SCRIPT_DIR/templates/route0.vhd $ACT_DIR/FT
                       cp $SCRIPT_DIR/templates/voterPRM.vhd $ACT_DIR/FT
                       cp $SCRIPT_DIR/templates/voter.vhd $ACT_DIR/FT
                       ls $ACT_DIR/FT
                       python $SCRIPT_DIR/entity_wrapper.py -r $ACT_DIR/FT/route0.vhd -f $ACT_DIR/FT/${filename##*/}  -o $ACT_DIR/FT/route0PRM.vhd -n route0PRM
                       ;;
    "TMR")             cp $SCRIPT_DIR/templates/route1.vhd $ACT_DIR/FT
                       python $SCRIPT_DIR/entity_wrapper.py -r $ACT_DIR/FT/route1.vhd -f $ACT_DIR/FT/${filename##*/}  -o $ACT_DIR/FT/route1PRM.vhd -n route1PRM
                       ;;
    "CheckerDuplex")   cp $SCRIPT_DIR/templates/route2.vhd $ACT_DIR/FT
                       python $SCRIPT_DIR/entity_wrapper.py -r $ACT_DIR/FT/route2.vhd -f FT/${filename##*/}  -o $ACT_DIR/FT/route2PRM.vhd -n route2PRM
                       ;;
esac 
