library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity simple_counter is
    generic( 
        DATA_WIDTH: integer := 8 
    );
    port( 
        CLK      : in std_logic;
        RST      : in std_logic;
        CLR      : in std_logic;
        EN       : in std_logic;
        DATA     : out std_logic_vector(DATA_WIDTH-1 downto 0)
    ); 
end simple_counter;


architecture counter_behavioral of simple_counter is
signal counter_reg : std_logic_vector(DATA_WIDTH-1 downto 0);

begin
    process (RST, CLK, CLR, EN)
    begin
        if (RST = '1') then
            counter_reg <= (others => '0');
        elsif (CLK'event) and (CLK = '1') then
	          if (CLR = '1') then
                counter_reg <= (others => '0');
	          elsif (EN = '1') then
                counter_reg <= counter_reg + 1;
            end if;
        end if;      
    end process;
    DATA <= counter_reg;
end counter_behavioral;

